/**
 * webSQL plugin
 * @param  {[type]} $ [description]
 * @return {[type]}   [description]
 */
(function($){
	var DB_VERSION = 1;
	var DB_SIZE = 10 * 1024 * 1024;
	var DB_DESCRIPTION = "Default description";

	var promise = {
		"db" : function(dbName, version, size, description) {
			if(version) {
				DB_VERSION = version;
			}
			if(size){
				DB_SIZE = size;
			}
			if(description) {
				DB_DESCRIPTION = description
			}

			return $.Deferred(function(dfd) {
				var db = openDatabase(dbName, DB_VERSION, DB_DESCRIPTION, DB_SIZE);
				db.onSuccess = function(tx, r) {
					console.log('success openeing database');
				}
				db.onError = function(tx, e) {
					console.log('failed opening database')
				}
			});
		},

		"transaction" : function() {

		},

		"objectStore" : function() {

		}
	}

	$.extend($.jsonStoreDB_plugins.webSQL,{
		"getDbPromise" : function(dbName, version) {
			return promise.db(dbName, version);
		},

		"getObjectStorePromise" : function(dbPromise, storeName) {
			return promise.objectStore(dbPromise, storeName);
		}
	})
})(jQuery);


// (function($){
// 	$.extend({
// 		"jsonStorageDB_engine" : function() {
// 			var db;
			
// 			return {
// 				db: null,
// 				create: function(dbName, objectStoreName){
					
// 				},
				
// 				//?????
// 				getKeys: function(objectStore){
					
					
// 				},
				
// 				transaction: function(dbName, objectStoreName) {
					
// 					this.create(dbName, objectStoreName);

// 					var self = this;
					
// 					var trans = ??;
// 					var store = ??;
					  
					
// 					return {
// 						save : function(data, key, force){
// 							//save and return a promise
// 							return $.Deferred(function(dfd){
// 								/**
// 								 * implemetation needed
// 								 */
// 							}).promise();
// 						},
						
// 						get : function(key){
// 							return $.Deferred(function(dfd){
// 								/**
// 								 * implemetation needed
// 								 */
// 							}).promise();
// 						},
						
// 						getAll : function(){
// 							return $.Deferred(function(dfd){
// 								/**
// 								 * implemetation needed
// 								 */
// 							}).promise();
// 						},
						
// 						delete : function(key, force){
// 							//delete a object by key
// 							return $.Deferred(function(dfd){
// 								/**
// 								 * implemetation needed
// 								 */
// 							}).promise();
// 						},
						
// 						getKeys : function(){
// 							//return th array of keys
// 							return $.Deferred(function(dfd){
// 								/**
// 								 * implemetation needed
// 								 */
// 							}).promise();
// 						},
												
// 						objectStore : function(){
// 							//return the store
// 						}
// 					}
// 				}
// 			}
// 		}
// 	});
// })(jQuery);